library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity fifo2 is
 port
  (
    rst       : in std_logic;--reset
    wr_en     : in std_logic;--criture autorise
    wr_clk    : in std_logic;-- horloge d'criture
    wr_data   : in std_logic_vector( 7 downto 0 );-- donne d'entre=>8 bits
    rd_en     : in std_logic;-- lecture autorise
    rd_clk    : in std_logic;-- horloge d'criture
    rd_data   : out std_logic_vector( 7 downto 0 )-- donne de sortie => 8bits
   
	);
	
end entity;


architecture archfifo of fifo2 is

  type memory_type is array ( 0 to 4095 ) of std_logic_vector(7 downto 0);-- memoire de 4kb

  signal memory : memory_type:=(others=>x"00");-- valeur mise  0 par dfaut
  signal wr_ptr : integer range 0 to 4095;-- chelle de valeurs prise par wr_ptr
  signal rd_ptr : integer range 0 to 4095;--chelle de valeurs prise par rd_ptr


begin

  process ( wr_clk)-- criture dans la fifo
  begin
	
	if (wr_clk'event and wr_clk='1') then-- dclenchement sur front montant du signal d'horloge ecriture
		
		if rst='1' then -- si reset vaut 1 alors
		wr_ptr <= 0;-- mise a zero du pointeur ecriture"wr_ptr"
        
      elsif wr_en='1' then --sinon si "wr_en = 1" => criture autorise

       memory(wr_ptr) <= wr_data;-- mise de la donne wr_data dans la memoire  l'adresse pointe par "wr-ptr" qui est au dbut 0
		wr_ptr <= (wr_ptr+1);-- aprs l'criture, wr_ptr est incrment de +1
		
        end if;
           
        end if;
    
  end process; 


  process ( rd_clk, memory)-- lecture de la fifo
 
 begin

    if (rd_clk'event and rd_clk='1') then -- dclenchement sur front montant de l'horloge de lecture

      if rst='1' then -- si reset vaut '1' alors

        rd_ptr <= 0;-- le pointeur de lecture vaut '0'

      elsif rd_en='1' then -- sinon, si rd_en est gale  '1' alors
		
		rd_data <= memory(rd_ptr);-- la donne prsente  l'adresse "0" est envoye sur rd_data
		rd_ptr <= (rd_ptr+1);-- aprs la lecture, le pointeur rd_ptr est incrment de +1
		
		end if;
		
      end if;
				 
  end process;
   
end architecture;