-- code pour l'interpolateur 8 bits


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity interpolateur_8_bits is
    Port ( data_fifo_1 : in  STD_LOGIC_VECTOR (7 downto 0);-- donnes venant de la FIFO1
           data_fifo_2 : in  STD_LOGIC_VECTOR (7 downto 0);-- donnes venant de la FIFO2
           sel_fifo : in  STD_LOGIC_VECTOR (1 downto 0);-- mode de slection des FIFO utilises pour le calcul
	 	sync : in  STD_LOGIC;-- bit de synchro servant  insrer le signal de synchro
	 	vidon : in  STD_LOGIC;-- signal vido active, si nul, niveau noir inject
           interpolateur_data_out : out  STD_LOGIC_VECTOR (7 downto 0));-- signal interpol
end interpolateur_8_bits;

architecture Behavioral of interpolateur_8_bits is

signal sig_interpolateur_data_out: std_logic_vector(7 downto 0);-- signal interne 
signal sel : std_logic_vector(3 downto 0);-- signal interne
		
begin

sel <= sync & vidon & sel_fifo;-- sel est  gal  la concatnation de ces 3 signaux

with sel select -- action  effectuer sur sig_interpolateur_data_out en fonction du rsulaltat de sel

sig_interpolateur_data_out <= "01000000" when "0000"|"0001"|"0010"|"0011"|"1100"|"1101"|"1110"|"1111",--niveau noir
			data_fifo_1 when "0100",--signal video fifo1
			(('0' & (data_fifo_1(7 downto 1))) + ('0' & (data_fifo_2(7 downto 1)))) when "0101"|"0110",--signal video fifo1 et fifo2
			data_fifo_2 when "0111",--signal video fifo2
			"00000000" when others;
interpolateur_data_out <= sig_interpolateur_data_out;
end Behavioral;
